****************************************************
*
* WritePixel Demonstration V1.05
*
* (C) 2000 by Stefan Robl <stefan@qdev.de>
*
* Web:   www.qdev.de
*
* This demo program draws a colorful gradient which
* can be moved with the mouse. The gradient colors
* change depending to the mouse position and change
* also with time.
* The window is now also resizable.
*
* ----> Based on a TAO ave demo.
*
****************************************************

.include 'taort'
.include 'ave/toolkit/toolkit'

COLORSPEED=4
WINDOW_START_SIZEX=350
WINDOW_START_SIZEY=350
WINDOW_MAX_SIZEX=800
WINDOW_MAX_SIZEY=800

tool 'demo/qdev/writepixel',VP,F_MAIN,16384,0

	ent -:-

	defbegin 0
	defp ave,app,tkit,win,pix,pixels,avo,msg,cnt,prp,layout,scrollpane,scrollpanecnt
	defi evt,mx,my,xx,yy,ww,wh,alpha

        cpy WINDOW_START_SIZEX,ww
        cpy WINDOW_START_SIZEY,wh

	qcall lib/argcargv,(-:p~,i~)

	; find the ave
	qcall sys/kn/dev/lookup,(avename.p:ave,app)
	ifnoterrno ave,true
		; open ave
		ncall ave,open,(ave,app,0,0:app)
		ifnoterrno app,true
			; open toolkit
			ncall ave,opentoolkit,(ave:tkit)
			if tkit!=0
				; get application props
				ncall app,getprop,(app:prp)

				; open dialog window
				ncall tkit,createdialog,(tkit,prp,appname.p,0.p,ww,wh,FDI_INNER|FDI_CLOSE|FDI_BORDER|FDI_TITLE|FDI_CONTENT|FDI_DRAG|FDI_CLOSE|FDI_RESIZE:win)
				if win!=0
					; get content gadget
                    			ncall win,getgadgets,(win:p~,p~,cnt)

					qcall ave/layout/scrollpane/open,(128,128:layout)
                    			if layout!=0
                        			ncall cnt,addlayout,(cnt,layout:-)

                        			ncall tkit,createscrollpane,(tkit,prp,0,0,0,FSP_CONTENT:scrollpane)   ; (no scroll bars required.)
                        			if scrollpane!=0
                            				; add scrollpane to window content.
                     					ncall cnt,add,(cnt,scrollpane,0:-)

                            				; get scrollpane gadget content.
                            				ncall scrollpane,getgadgets,(scrollpane:p~,p~,scrollpanecnt)

                            				; set scrollpane and content to determined size
                            				ncall scrollpanecnt,setsize,(scrollpanecnt,WINDOW_MAX_SIZEX,WINDOW_MAX_SIZEY:-)
                            				ncall scrollpane,change,(scrollpane,0,0,WINDOW_MAX_SIZEX,WINDOW_MAX_SIZEY,CM_NONE:-)

							; open pixel buffer
							qcall lib/malloc,(WINDOW_MAX_SIZEX*WINDOW_MAX_SIZEY*4:pixels)
   							if pixels!=NULL
								; open main pixmap
								qcall ave/avo/pix/32bit/open,(pixels,WINDOW_MAX_SIZEX,WINDOW_MAX_SIZEY,WINDOW_MAX_SIZEX*4:pix)			
								if pix!=0
									;add to content gadget, set alphamode and clear opaque
									ncall pix,setflags,(pix,FAVO_ALPHA,FAVO_ALPHA|FAVO_OPAQUE:-)
									ncall scrollpanecnt,add,(scrollpanecnt,pix,0:-)
								
									;add window to app, link window action to app quit
									ncall win,addlink,(win,app,CH_DIALOG_ACTION,EV_QUIT:i~)
									ncall app,add,(app,win,0:-)

									;update window
									ncall win,update,(win:-)

									defl timeout
									defi step,greenpart

									clr greenpart
									cpy ww/2,mx
									cpy wh/2,my
									
									cpy COLORSPEED,step
                                                    			cpy.l (CLOCKS_PER_SEC/25),timeout ; we want 25 FPS

									repeat
										ncall app,getevent,(app,timeout:avo,msg,evt)
										if avo!=0
											;pass out to event handler
											ncall avo,event,(avo,msg,evt:-)

											; handle events
											if evt=EV_TRACKING
												cpy [msg+EVD_RX],mx
												cpy [msg+EVD_RY],my
												gos draw_pixels,(pixels,pix,ww,wh,mx,my,greenpart:-)
											elseif evt=EV_DIALOG_RESIZE
												defi oww,owh
												cpy ww,oww
												cpy wh,owh
												ncall cnt,getsize,(cnt:ww,wh)
												if ((ww!=oww) || (wh!=owh))	
													gos draw_pixels,(pixels,pix,ww,wh,mx,my,greenpart:-)
												endif
											endif

											;free event
											ncall ave,freeevent,(ave,msg:-)
										else ; timeout
											gos changestep,(step,greenpart:step,greenpart)
											gos draw_pixels,(pixels,pix,ww,wh,mx,my,greenpart:-)
										endif
									until evt=EV_QUIT

								endif ; if pix!=0
							else  ; if pixels!=0
								tracef "Error: Not enough memory for image buffer!\n"
							endif ; if pixels!=0
                        			endif ; (create scrollpane)
                    			endif ; (create scrollpane layout)
				endif ; if win!=0
				;close toolkit
				ncall ave,closetoolkit,(ave,tkit:-)
			endif ; if tkit!=0
			;close ave
			ncall ave,close,(ave,app:i~)
		endif ; ifnoterrno app,true
		;exit
		qcall lib/exit,(0:-)
	endif ; ifnoterrno ave,true
	
	ret
	defendnz



changestep:
	defbegin 0
	defi step,color
	ent step color:step color

	add step,color
	
	if ((color<0) || (color>255))
		cpy -step,step
		add step,color
	endif
	
	ret		
	defendnz


draw_pixels:
	defbegin 0
	defp pixels,pix
	defi ww,wh,mx,my,greenpart

	defd dist
	defi aa,bb,xx,yy

	ent pixels pix ww wh mx my greenpart:-

	cpy (greenpart & $FF)<<8,greenpart
		
	clr yy
	repeat
		clr xx
		repeat
			cpy (mx-xx),aa
			mul aa,aa
			cpy (my-yy),bb
			mul bb,bb
			cpy i2d (aa+bb),dist

			qcall lib/sqrt,(dist:dist)
			cpy d2ir dist,aa

			if aa>255
				cpy 255,aa
			elseif aa<0
				cpy 0,aa
			endif
				
			cpy (aa<<24),bb     ; alpha part
																							
			cpy ((mx<<8)/ww),aa
			or (aa<<16),bb      ; red part

			or greenpart,bb       ; green part
			cpy ((my<<8)/wh),aa 

			or (aa),bb          ; blue part

			cpy.i bb,[pixels]
			add 4,pixels
									
			inc xx
		until xx=ww
		add (WINDOW_MAX_SIZEX-ww)<<2,pixels
		inc yy
	until yy=wh
	
	ncall pix,update,(pix:-)

	ret
	defendnz

	data
avename:
	dc.b '/device/ave/'
appname:
	dc.b 'WritePixel Demonstration V1.05',0

toolend

.end


